#
# * 9.2 Функция-генератор. Оператор yield
#
'''
Подвиг 1. Вводится натуральное число N. Необходимо определить
функцию-генератор с именем get_sum, которая бы возвращала текущую сумму
чисел последовательности длины N в диапазоне целых чисел [1; N].
Например:
- для первого числа 1 сумма равна 1;
- для второго числа 2 сумма равна 1+2 = 3
....
- для N-го числа сумма равна 1+2+...+(N-1)+N
Реализовать функцию-генератор get_sum без использования коллекций.
Вызывать ее не нужно, только определить.
Sample Input:
5
Sample Output:
1 3 6 10 15
'''

# def get_sum(n: int):
#     s = 0
#     for i in range(1 ,n + 1):
#         s += i
#         yield s
# Test
# print(list(get_sum(5)))
'''
Подвиг 2. Мы с вами в заданиях несколько раз генерировали
последовательность чисел Фибоначчи, которая строится по правилу: каждое
последующее число равно сумме двух предыдущих. Для разнообразия давайте
будем генерировать каждое последующее как сумму трех предыдущих чисел.
При этом первые три числа равны 1 и имеем такую последовательность:
1, 1, 1, 3, 5, 9, 17, 31, 57, ...
Не знаю, есть ли у нее название, поэтому, в рамках уроков, я скромно
назову ее последовательностью Балакирева. 
Итак, на вход программы поступает натуральное число N (N > 5) и
необходимо определить функцию-генератор, которая бы возвращала N первых
чисел последовательности Балакирева (включая первые три единицы).
Реализуйте эту функцию без использования коллекций (списков, кортежей,
словарей и т.п.). Вызовите ее N раз для получения N чисел и выведите
полученные числа на экран в одну строчку через пробел.
Sample Input:
7
Sample Output:
1 1 1 3 5 9 17
'''
# def get_bn(N: int):
#     a, b, c = 1, 1, 1
#     bn = 0
#     for i in range(1, N + 1):
#         if i < 4:
#             yield 1
#         else:
#             bn = a + b + c
#             a, b, c = b, c, bn
#             yield bn

# print(*get_bn(int(input())))
'''
Подвиг 3. Вводится натуральное число N (N > 8). Необходимо определить
функцию-генератор, которая бы выдавала пароль длиной N символов из
случайных букв, цифр и некоторых других знаков. Для получения
последовательности допустимых символов для генерации паролей в программе
импортированы две строки: ascii_lowercase, ascii_uppercase (см. листинг
ниже), на основе которых формируется общий список:
from string import ascii_lowercase, ascii_uppercase
chars = ascii_lowercase + ascii_uppercase + "0123456789!?@#$*"
Функция-генератор должна при каждом вызове возвращать новый пароль из
случайно выбранных символов chars длиной N и делать это бесконечно, то
есть, вызывать ее можно бесконечное число раз. Сгенерировать случайный
индекс indx в диапазоне [a; b] для символа можно с помощью функции
randint модуля random:

import random
random.seed(1)
indx = random.randint(a, b)
Сгенерируйте с помощью этой функции первые пять паролей и выведите их в
столбик (каждый с новой строки).
Sample Input:
10
Sample Output:
riGp?58WAm
!dX3a5IDnO
dcdbWB2d*C
4?DSDC6Lc1
mxLpQ@2@yM
'''

# import random
# from string import ascii_lowercase, ascii_uppercase

# # установка зерна датчика случайных чисел (не менять)
# random.seed(1)

# # здесь продолжайте программу
# def get_passwd(N: int):
#     chars = ascii_lowercase + ascii_uppercase + "0123456789!?@#$*"
#     while True:
#         yield ''.join(chars[random.randint(0, len(chars))] for _ in range(N))

# N = int(input())
# for _ in range(5):
#     print(next(get_passwd(N)))
'''
Подвиг 4. Вводится натуральное число N. Используя строки из латинских
букв ascii_lowercase и ascii_uppercase:
from string import ascii_lowercase, ascii_uppercase
chars = ascii_lowercase + ascii_uppercase
задайте функцию-генератор, которая бы возвращала случайно сформированные
email-адреса с доменом mail.ru и длиной в N символов. Например, при N=6,
получим адрес: SCrUZo@mail.ru
Для формирования случайного индекса для строки chars используйте функцию randint модуля random:
import random
random.seed(1)
indx = random.randint(0, len(chars)-1)
Функция-генератор должна возвращать бесконечное число таких адресов, то
есть, генерировать постоянно. Выведите первые пять сгенерированных email
и выведите их в столбик (каждый с новой строки).
Sample Input:
8
Sample Output:
iKZWeqhF@mail.ru
WCEPyYng@mail.ru
FbyBMWXa@mail.ru
SCrUZoLg@mail.ru
ubbbPIay@mail.ru
'''
# import random
# from string import ascii_lowercase, ascii_uppercase

# # установка зерна датчика случайных чисел (не менять)
# random.seed(1)


# def get_email(N: int):
#     chars = ascii_lowercase + ascii_uppercase
#     while True:
#         yield ''.join(chars[random.randint(0, len(chars))]
#                     for _ in range(N)) + '@mail.ru'

# N = int(input())
# [print(next(get_email(N)), sep='\n') for _ in range(5)]

'''
Подвиг 5. Определите функцию-генератор, которая бы возвращала простые
числа. (Простое число - это натуральное число, которое делится только на
себя и на 1). Выведите с помощью этой функции первые 20 простых чисел
(начиная с 2) в одну строчку через пробел.
'''
# ! Не очень понял, но наступил на эти грабли:
'''
Важно учитывать, что есть принципиальная разница между вызовом
функции-генератора непосредственно, как, например, next(function()),
и неявным вызовом - через посредство переменной:
next(f), где f = function()
В первом случае функция-генератор каждый раз вызывается заново, так что
она не сохраняет своё текущее состояние и не происходит перебора
генерируемых ею значений (каждый раз генерируется первое значение).
Во втором случае функция вызывается единожды, а затем работает как
генератор, как и должна. Я стормозил и сперва не мог понять, почему у
меня всё время выводит двадцать двоек, хотя всё вроде бы должно было
работать, как надо.
'''
def get_prime_numbers():
    n = 1
    while True:
        n += 1
        prime = not any(n % i == 0 and n != i for i in range(2, n + 1))
        if prime:
            yield n

f = get_prime_numbers()
[print(next(f), end=' ') for _ in range(20)]